<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE></TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 2.3  (Linux)">
	<META NAME="CREATED" CONTENT="20070803;11592800">
	<META NAME="CHANGED" CONTENT="20070803;12322700">
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<P STYLE="margin-bottom: 0in"><FONT SIZE=6><B>CYK Parser</B></FONT></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in">Contents</H2>
<P STYLE="margin-bottom: 0in"><A HREF="#Introduction|outline"><U>Introduction</U></A><A HREF="#How to Open User Control Parse Window|outline"><BR></A><A HREF="#How to Run CYK Parse|outline"><U>How
to Run CYK Parser</U></A></P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="Introduction|outline"></A>
Introduction</H2>
<P STYLE="margin-bottom: 0in">In the previous version of JFLAP, user
had to rely on brute force parser to check whether certain string is
accepted by the grammar or not. Unfortunately, brute force parser
could take quite long time to parse the input. To improve efficiency
in parsing, CYK Parser has been implemented in new version of JFLAP. 
</P>
<P STYLE="margin-bottom: 0in">CYK Parser transforms the given grammar
into CNF form and performs CYK parsing algorithm to check the
string's membership in the grammar. 
</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="How to Run CYK Parse|outline"></A>
How to Run CYK Parser</H2>
<P>We will begin by entering a new grammar. You can either enter the
grammar (shown below) or load the file <A HREF="grammarForCYK.jff">grammarForCYK.jff</A>.
</P>
<P><BR><BR>
</P>
<P ALIGN=CENTER><A NAME="editor"></A><IMG SRC="images/example1_1.png" NAME="Graphic0" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P><BR><BR>
</P>
<P>Then you can click on <B>Input,</B> followed by <B>CYK Parse</B>.
After clicking <B>CYK Parse</B>, you should see a window that is very
similar to <B>Brute Force Parse</B> window.</P>
<P><BR><BR>
</P>
<P ALIGN=CENTER><A NAME="editor1"></A><IMG SRC="images/example1_2.png" NAME="Graphic1" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now you can input a string
and to check its membership in the grammar. Enter the string “aabbb”.
Immediately, you will see the answer on the panel telling you that
the string is accepted.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_3.png" NAME="Graphic3" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Since the string is accepted
by the grammar, you can try to see which productions were applied to
achieve our input string by clicking <B>STEP </B><SPAN STYLE="font-weight: medium">button.
You can also </SPAN><B>Click</B> on <B>Derivation Table</B><SPAN STYLE="font-weight: medium">
to see which production rule has been applied to the input string.
After clicking one </SPAN><B>STEP </B><SPAN STYLE="font-weight: medium">button,
y</SPAN>our window should look like one of these : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_4.png" NAME="Graphic6" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_5.png" NAME="Graphic4" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">After clicking <B>STEP</B><SPAN STYLE="font-weight: medium">
until the end, you will see either entire tree or derivation table of
how the input string has been accepted by the grammar</SPAN>.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_6.png" NAME="Graphic6" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_7.png" NAME="Graphic7" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>CYK Parse </B><SPAN STYLE="font-weight: medium">works
so much faster than traditional </SPAN><B>Brute Force Parse</B><SPAN STYLE="font-weight: medium">.
You can see the remarkable difference in speed, i</SPAN>f you try to
parse input string as “aaaabbbbb” with the same grammar in <B>Brute
Force Parse</B><SPAN STYLE="font-weight: medium">.</SPAN> It would
probably take long time to get the result. However, CYK Parse will
immediately tell you that the string is accepted by the grammar. 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>*NOTE:</B> <SPAN STYLE="font-weight: medium">You
can also perform multi-run with CYK Parser as you did with Brute
Force Parser. </SPAN>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>This concludes our brief
tutorial on CYK Parsing. Thanks for reading!</B></P>
</BODY>
</HTML>